/* -*- coding: utf-8 -*- */
#include "joy_data.h"

extern int verbosity;
extern int list_devices;
extern int list_sdl_devices;

void detect_joysticks() {
  int i = 0, j = 0, active = 0;
  char buf[100];

  if (list_devices == 1) { puts("List of joystick devices:"); }
  else if (list_sdl_devices == 1) { puts("List of SDL joystick devices:"); }

  /* only maintain state of joysticks that are actually joysticks */
  for (i = 0; i < NUM_JOYS; i++) {
    SDL_Joystick *joy = SDL_JoystickOpen(i);
    int num_axes = SDL_JoystickNumAxes(joy);
    int num_hats = SDL_JoystickNumHats(joy);
    int num_btns = SDL_JoystickNumButtons(joy);
    active = (num_axes > 0 || num_hats > 0 || num_btns > 0) ? 1 : 0;

    if (list_sdl_devices == 1) {
      sprintf(buf, "joy %d: %d axes, %d hats, %d buttons",
              i, num_axes, num_hats, num_btns);
      puts(buf);
    }
    else if (list_devices == 1 && active == 1) {
      sprintf(buf, "joy %d: %d axes, %d hats, %d buttons",
              j, num_axes, num_hats, num_btns);
      puts(buf);
      j++;
    }
    else if (active == 1 && cfg_map[j] == 1) {
      sprintf(buf, "joy %d configured: ready", j);
      if (verbosity >= 0) { puts(buf); }
      joys[j] = joy; dev_map[i] = j; j++;
    }
    else if (active == 1 && cfg_map[j] == -1) {
      sprintf(buf, "joy %d ignored: not configured in specified profile", j);
      if (verbosity >= 0) { puts(buf); }
      dev_map[i] = -1;
    }
    else { dev_map[i] = -1; }
  }
  /* use j for number of joysticks since some of the original were ignored */
  NUM_JOYS = j;
  /* if we are merely listing devices, then exit here... */
  if (list_devices == 1 || list_sdl_devices == 1) { SDL_Quit(); exit(0); }
}
