/* -*- coding: utf-8 -*- */
#include <stdio.h>
#include <stdlib.h>
#include "joy_data.h"

int max(int a, int b) { return (a > b ? a : b); }
int min(int a, int b) { return (a < b ? a : b); }

#define Succeed 0
#define Fail -1
#define Local 0
#define System_Wide 1

/* return 0 if file exists, otherwise return negative number */
int file_exists(char* filename) {
  fn = fopen (filename, "r");
  if (fn) { fclose(fn); return Succeed; }
  else { return Fail; }
}

/* Returns 0 for a local configuration file, 1 for a system-wide configuration
   file; note that if present, the local configuration file always takes
   priority over the system-wide configuration file... */
int handle_config(char* fn, char* local_fn) {
  if (file_exists(local_fn) >= 0) { return Local; }
  else if (file_exists(fn) >= 0) { return System_Wide; }
  else {
    printf("no configuration file found in %s or %s\n", fn, local_fn);
    exit(Fail);
  }
}

int system_config_filename(char* profile, char* ret) {
  strcpy(ret, "");
  strcat(ret, PREFIX);
  strcat(ret, "/share/joytran/profiles/");
  strcat(ret, profile);
  return 0;
}
int local_config_filename(char* profile, char* ret) {
  strcpy(ret, "");
  strcat(ret, getenv("HOME"));
  strcat(ret, "/.joytran/profiles/");
  strcat(ret, profile);
  return 0;
}

void die(const char* err) { printf("metalock: %s", err); exit(Fail); }
